﻿using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

/* Visual Studio freezes during the Sandcastle build and there's no way to use MSBuild to get a warning
 * visible in the output window before Sandcastle starts.  The Message and Warning tasks do not show up
 * until after the build has completed.  A conditional compilation warning was the next best choice since
 * the C# compiler is able to show warnings immediately, probably because Visual Studio has special 
 * handling for it.
 */
#if !DEBUG && !PROFILING
#warning *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
#warning Building documentation with Sandcastle...
#warning
#warning This could take several minutes.  Visual Studio will be unresponsive, so please be patient.
#warning *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
#endif

[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA2210:AssembliesShouldHaveValidStrongNames")]

// General Information about an assembly is controlled through the following 
// set of attributes. Change these attribute values to modify the information
// associated with an assembly.
#if !EXPERIMENTAL
[assembly: AssemblyTitle("Rxx for Windows Phone 7.0")]
[assembly: AssemblyDescription("Reactive LINQ extensions supplementary to Microsoft's Reactive Extensions for .NET (Rx).")]
#else
[assembly: AssemblyTitle("Rxx for Windows Phone 7.0 (Experimental Release)")]
[assembly: AssemblyDescription("Reactive LINQ extensions supplementary to Microsoft's Reactive Extensions for .NET (Rx - Experimental).")]
#endif

// Setting ComVisible to false makes the types in this assembly not visible 
// to COM components.  If you need to access a type in this assembly from 
// COM, set the ComVisible attribute to true on that type.
[assembly: ComVisible(false)]

// The following GUID is for the ID of the typelib if this project is exposed to COM
[assembly: Guid("03c771d0-8da4-4b1c-abb4-f9f3bd21b468")]

// Version information for an assembly consists of the following four values:
//
//      Major Version
//      Minor Version 
//      Build Number
//      Revision
//
// You can specify all the values or you can default the Revision and Build Numbers 
// by using the '*' as shown below:
[assembly: AssemblyVersion("1.3.*")]
[assembly: AssemblyFileVersion("1.3.0.0")]
