﻿namespace System.Net.Sockets
{
	/// <summary>
	/// Represents the result of reading data from a <see cref="Socket"/>.
	/// </summary>
	public sealed class SocketResult
	{
		#region Public Properties
		/// <summary>
		/// Gets the number of bytes that were read.
		/// </summary>
		public int Count
		{
			get
			{
				return count;
			}
		}

		/// <summary>
		/// Gets the end point that sent the data.
		/// </summary>
		public EndPoint ActualRemoteEndPoint
		{
			get
			{
				return actualRemoteEndPoint;
			}
		}
		#endregion

		#region Private / Protected
		private readonly int count;
		private readonly EndPoint actualRemoteEndPoint;
		#endregion

		#region Constructors
		internal SocketResult(int count, EndPoint actualRemoteEndPoint)
		{
			this.count = count;
			this.actualRemoteEndPoint = actualRemoteEndPoint;
		}
		#endregion

		#region Methods

		#endregion
	}
}