﻿using System.Diagnostics.Contracts;
#if PORT_45
using System.Threading.Tasks;
#endif

namespace System.Reactive.Concurrency
{
	internal static class PlatformSchedulers
	{
		public static IScheduler Concurrent
		{
			get
			{
				Contract.Ensures(Contract.Result<IScheduler>() != null);

#if !PORT_45
				return ThreadPoolScheduler.Instance;
#else
				return new TaskPoolScheduler(TaskScheduler.Current ?? TaskScheduler.Default);
#endif
			}
		}
	}
}