﻿using System.Diagnostics.Contracts;

namespace System
{
	[ContractClass(typeof(IObservableContract<>))]
	public interface IObservable<T>
	{
		IDisposable Subscribe(IObserver<T> observer);
	}

	[ContractClassFor(typeof(IObservable<>))]
	internal abstract class IObservableContract<T> : IObservable<T>
	{
		public IDisposable Subscribe(IObserver<T> observer)
		{
			Contract.Requires(observer != null, null, "observer != null");
			Contract.Ensures(Contract.Result<IDisposable>() != null, null, "Contract.Result<IDisposable>() != null");
			return null;
		}
	}
}