﻿using System.Diagnostics.Contracts;

namespace System.Reactive.Concurrency
{
	public sealed class ImmediateScheduler : LocalScheduler
	{
		public static ImmediateScheduler Instance
		{
			get
			{
				Contract.Ensures(Contract.Result<ImmediateScheduler>() != null, null, "Contract.Result<ImmediateScheduler>() != null");
				return null;
			}
		}

		public override IDisposable Schedule<TState>(TState state, TimeSpan dueTime, Func<IScheduler, TState, IDisposable> action)
		{
			return null;
		}
	}
}