﻿using System.Diagnostics.Contracts;
using System.Threading;

namespace System.Reactive.Concurrency
{
	public sealed class NewThreadScheduler : LocalScheduler
	{
		public static NewThreadScheduler Default
		{
			get
			{
				Contract.Ensures(Contract.Result<NewThreadScheduler>() != null, null, "Contract.Result<NewThreadScheduler>() != null");
				return null;
			}
		}

		public NewThreadScheduler(Func<ThreadStart, Thread> threadFactory)
		{
			Contract.Requires(threadFactory != null, null, "threadFactory != null");
		}

		public override IDisposable Schedule<TState>(TState state, TimeSpan dueTime, Func<IScheduler, TState, IDisposable> action)
		{
			return null;
		}
	}
}