﻿using System.Diagnostics.Contracts;
using System.Threading.Tasks;

namespace System.Reactive.Concurrency
{
	public sealed class TaskPoolScheduler : LocalScheduler
	{
		public static TaskPoolScheduler Default
		{
			get
			{
				Contract.Ensures(Contract.Result<TaskPoolScheduler>() != null, null, "Contract.Result<TaskPoolScheduler>() != null");
				return null;
			}
		}

		public TaskPoolScheduler(TaskFactory taskFactory)
		{
			Contract.Requires(taskFactory != null, null, "taskFactory != null");
		}

		public override IDisposable Schedule<TState>(TState state, TimeSpan dueTime, Func<IScheduler, TState, IDisposable> action)
		{
			return null;
		}
	}
}