﻿using System.Diagnostics.Contracts;
using System.Linq.Expressions;
#if !WINDOWS_PHONE
using System.Threading;
using System.Threading.Tasks;
#endif

namespace System.Reactive.Linq
{
	public static partial class Qbservable
	{
		public static IQbservable<TSource> Using<TSource, TResource>(this IQbservableProvider provider, Expression<Func<TResource>> resourceFactory, Expression<Func<TResource, IObservable<TSource>>> observableFactory)
			where TResource : IDisposable
		{
			Contract.Requires(provider != null, null, "provider != null");
			Contract.Requires(resourceFactory != null, null, "resourceFactory != null");
			Contract.Requires(observableFactory != null, null, "observableFactory != null");
			Contract.Ensures(Contract.Result<IQbservable<TSource>>() != null, null, "Contract.Result<IQbservable<TSource>>() != null");
			return null;
		}

#if !WINDOWS_PHONE
		public static IQbservable<TSource> UsingAsync<TSource, TResource>(this IQbservableProvider provider, Expression<Func<CancellationToken, Task<TResource>>> resourceFactoryAsync, Expression<Func<TResource, CancellationToken, Task<IObservable<TSource>>>> observableFactoryAsync)
			where TResource : IDisposable
		{
			Contract.Requires(provider != null, null, "provider != null");
			Contract.Requires(resourceFactoryAsync != null, null, "resourceFactoryAsync != null");
			Contract.Requires(observableFactoryAsync != null, null, "observableFactoryAsync != null");
			Contract.Ensures(Contract.Result<IQbservable<TSource>>() != null, null, "Contract.Result<IQbservable<TSource>>() != null");
			return null;
		}
#endif
	}
}