﻿using System.Collections.Generic;
using System.Diagnostics.Contracts;
using System.Linq.Expressions;
using System.Reactive.Concurrency;
using System.Reactive.Joins;

namespace System.Reactive.Linq
{
	public static partial class Qbservable
	{
		public static IQbservable<TResult> When<TResult>(this IQbservableProvider provider, params QueryablePlan<TResult>[] plans)
		{
			Contract.Requires(provider != null, null, "provider != null");
			Contract.Requires(plans != null, null, "plans != null");
			//Contract.Requires(Contract.ForAll(plans, plan => plan != null), null, "Contract.ForAll(plans, plan => plan != null)");
			Contract.Ensures(Contract.Result<IQbservable<TResult>>() != null, null, "Contract.Result<IQbservable<TResult>>() != null");
			return null;
		}

		public static IQbservable<TResult> When<TResult>(this IQbservableProvider provider, IEnumerable<QueryablePlan<TResult>> plans)
		{
			Contract.Requires(provider != null, null, "provider != null");
			Contract.Requires(plans != null, null, "plans != null");
			//Contract.Requires(Contract.ForAll(plans, plan => plan != null), null, "Contract.ForAll(plans, plan => plan != null)");
			Contract.Ensures(Contract.Result<IQbservable<TResult>>() != null, null, "Contract.Result<IQbservable<TResult>>() != null");
			return null;
		}

		public static IQbservable<TSource> Where<TSource>(this IQbservable<TSource> source, Expression<Func<TSource, bool>> predicate)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Requires(predicate != null, null, "predicate != null");
			Contract.Ensures(Contract.Result<IQbservable<TSource>>() != null, null, "Contract.Result<IQbservable<TSource>>() != null");
			return null;
		}

		public static IQbservable<TSource> Where<TSource>(this IQbservable<TSource> source, Expression<Func<TSource, int, bool>> predicate)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Requires(predicate != null, null, "predicate != null");
			Contract.Ensures(Contract.Result<IQbservable<TSource>>() != null, null, "Contract.Result<IQbservable<TSource>>() != null");
			return null;
		}

		public static IQbservable<TSource> While<TSource>(this IQbservableProvider provider, Expression<Func<bool>> condition, IObservable<TSource> source)
		{
			Contract.Requires(provider != null, null, "provider != null");
			Contract.Requires(condition != null, null, "condition != null");
			Contract.Requires(source != null, null, "source != null");
			Contract.Ensures(Contract.Result<IQbservable<TSource>>() != null, null, "Contract.Result<IQbservable<TSource>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource, TWindowClosing>(this IQbservable<TSource> source, Expression<Func<IObservable<TWindowClosing>>> windowClosingSelector)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Requires(windowClosingSelector != null, null, "windowClosingSelector != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, int count)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, TimeSpan timeSpan)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, int count, int skip)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource, TWindowOpening, TWindowClosing>(this IQbservable<TSource> source, IObservable<TWindowOpening> windowOpenings, Expression<Func<TWindowOpening, IObservable<TWindowClosing>>> windowClosingSelector)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Requires(windowOpenings != null, null, "windowOpenings != null");
			Contract.Requires(windowClosingSelector != null, null, "windowClosingSelector != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, TimeSpan timeSpan, int count)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, TimeSpan timeSpan, IScheduler scheduler)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Requires(scheduler != null, null, "scheduler != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, TimeSpan timeSpan, TimeSpan timeShift)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, TimeSpan timeSpan, int count, IScheduler scheduler)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Requires(scheduler != null, null, "scheduler != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}

		public static IQbservable<IObservable<TSource>> Window<TSource>(this IQbservable<TSource> source, TimeSpan timeSpan, TimeSpan timeShift, IScheduler scheduler)
		{
			Contract.Requires(source != null, null, "source != null");
			Contract.Requires(scheduler != null, null, "scheduler != null");
			Contract.Ensures(Contract.Result<IQbservable<IQbservable<TSource>>>() != null, null, "Contract.Result<IQbservable<IQbservable<TSource>>>() != null");
			return null;
		}
	}
}