﻿using System.Diagnostics.Contracts;
using System.Windows.Forms;

namespace System.Reactive.Concurrency
{
	public class ControlScheduler : LocalScheduler
	{
		public Control Control
		{
			get
			{
				Contract.Ensures(Contract.Result<Control>() != null, null, "Contract.Result<Control>() != null");
				return null;
			}
		}

		public ControlScheduler(Control control)
		{
			Contract.Requires(control != null, null, "control != null");
			Contract.Ensures(object.ReferenceEquals(this.Control, control), null, "object.ReferenceEquals(this.Control, control)");
		}

		public override IDisposable Schedule<TState>(TState state, TimeSpan dueTime, Func<IScheduler, TState, IDisposable> action)
		{
			return null;
		}
	}
}